﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=12.2
@EndOfDesignText@
' Type : Class Message Box
' Author : zed - https://www.b4x.com/android/forum/members/zed.123596/
' Date : 06/07/2023
'
' Functioning
' Create a template with the designer.
' Panel1 (parent panel) : This is the background panel. set .visibile = false (popup)
' In panel1
' 1 panel for each element (title - content - image - and 1 or 2 or 3 buttons)
' In code
' Target = each elements create

Sub Class_Globals
	Private xui As XUI
	Private mEventName As String
	Private fName As String
	Private fSize, fColor As Int
	Private fontttf As B4XFont
	Private btfName As String
	Private btfSize, btfColor As Int
	Private btfontttf As B4XFont
	Private lblTitle As Label
	Private lblcontant As Label
	Private imv As ImageView
	
	Private bImageName As String
	Private bt1 As Button
	Private bt2 As Button
	Private bt3 As Button
	
	Private tTop As Int
	Private tTitle As Panel
	Private tContent As Panel
	Private tImage As Panel
	Private tButton1 As Panel
	Private tButton2 As Panel
	Private tButton3 As Panel
	
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize (EventName As String)
	mEventName = EventName
	fontttf = xui.CreateFont(Typeface.DEFAULT,18)
	fSize = 18
	fColor = xui.Color_Black
End Sub

Public Sub Font(Name As String, Size As Int, Color As Int)
	fName = Name
	fSize = Size
	fColor = Color
	fontttf = xui.CreateFont(Typeface.LoadFromAssets(fName),fSize)
End Sub

Public Sub Title(Target As Panel, mtitle As String)
	lblTitle.Initialize("")
	lblTitle.Width = Target.Width
	lblTitle.Height = Target.Height
	Dim l As B4XView = lblTitle
	l.Font = fontttf
	lblTitle.TextColor = fColor
	lblTitle.TextSize = fSize
	lblTitle.Gravity = Gravity.CENTER
	lblTitle.Text = mtitle
	tTitle = Target
	'Target.AddView(lblTitle,0,0,Target.Width,Target.Height)
	
End Sub

Public Sub Content(Target As Panel, mContent As String)
	
	lblcontant.Initialize("")
	lblcontant.Width = Target.Width
	lblcontant.Height = Target.Height
	Dim l As B4XView = lblcontant
	l.Font = fontttf
	lblcontant.TextColor = fColor
	lblcontant.TextSize = fSize
	lblcontant.Gravity = Gravity.CENTER
	lblcontant.Text = mContent
	tContent = Target
	'Target.AddView(lblcontant,0,0,Target.Width,Target.Height)
End Sub

Public Sub image(Target As Panel, mImage As String)
	'If mImage <> "" Then
		Dim im As B4XBitmap
		imv.Initialize("")
		im = xui.LoadBitmapResize(File.DirAssets,mImage,Target.Width,Target.Height,True)
		imv.SetBackgroundImage(im)
		tTop = (((Target.Height/xui.Scale) - (im.Width/xui.Scale))/2)/xui.Scale 'problem vertical alignment
		'tTop = (Target.Height - im.Width /2 )
		tImage = Target
		'Target.AddView(imv,0,t,im.Width,im.Height)
	'End If
End Sub

Public Sub ButtonImage(mImage As String)
	bImageName = mImage
End Sub

Public Sub ButtonFont(Name As String, Size As Int, Color As Int)
	btfName = Name
	btfSize = Size
	btfColor = Color
	btfontttf = xui.CreateFont(Typeface.LoadFromAssets(btfName),fSize)
End Sub

Public Sub Button1(Target As Panel, Text As String)
	bt1.Initialize("Button")
	bt1.Width = Target.Width
	bt1.Height = Target.Height
	bt1.Text = Text
	tButton1 = Target
	Dim im As B4XBitmap
	im = xui.LoadBitmapResize(File.DirAssets,bImageName,Target.Width,Target.Height,True)
	Dim b1 As B4XView = bt1
	b1.SetBitmap(im)
	b1.Font = btfontttf
	b1.TextColor = btfColor
	b1.TextSize = btfSize
	'Target.AddView(btYes,0,0,Target.Width,Target.Height)
End Sub

Public Sub Button2(Target As Panel, Text As String)
	bt2.Initialize("Button")
	bt2.Width = Target.Width
	bt2.Height = Target.Height
	bt2.Text = Text
	tButton2 = Target
	Dim im As B4XBitmap
	im = xui.LoadBitmapResize(File.DirAssets,bImageName,Target.Width,Target.Height,True)
	Dim b2 As B4XView = bt2
	b2.SetBitmap(im)
	b2.Font = btfontttf
	b2.TextColor = btfColor
	b2.TextSize = btfSize
	'Target.AddView(btNo,0,0,Target.Width,Target.Height)
End Sub

Public Sub Button3(Target As Panel, Text As String)
	bt3.Initialize("Button")
	bt3.Width = Target.Width
	bt3.Height = Target.Height
	bt3.Text = Text
	tButton3 = Target
	Dim im As B4XBitmap
	im = xui.LoadBitmapResize(File.DirAssets,bImageName,Target.Width,Target.Height,True)
	Dim b3 As B4XView = bt3
	b3.SetBitmap(im)
	b3.Font = btfontttf
	b3.TextColor = btfColor
	b3.TextSize = btfSize
	'Target.AddView(btCancel,0,0,Target.Width,Target.Height)
End Sub

Private Sub Button_Click
	Dim btn As Button = Sender
	mEventName = mEventName&"_Result"
	CallSubDelayed2(B4XPages.MainPage,mEventName,btn.Text)
End Sub

Public Sub show
	tTitle.AddView(lblTitle,0,0,tTitle.Width,tTitle.Height)
	tContent.AddView(lblcontant,0,0,tContent.Width,tContent.Height)
	tImage.AddView(imv,0,tTop,tImage.Width,tImage.Height)
	tButton1.AddView(bt1,0,0,tButton1.Width,tButton1.Height)
	tButton2.AddView(bt2,0,0,tButton2.Width,tButton2.Height)
	tButton3.AddView(bt3,0,0,tButton3.Width,tButton3.Height)
End Sub



